"
 COPYRIGHT (c) 1989 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

ParseNode subclass:#PrimaryNode
	 instanceVariableNames:'value'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'System-Compiler-Support'
!

!PrimaryNode class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1989 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    node for parse-trees, representing primaries (variables & literals)
"
! !

!PrimaryNode methodsFor:'accessing'!

value
    ^ value
! !

!PrimaryNode methodsFor:'code generation'!

codeForSideEffectOn:aStream inBlock:b for:aCompiler
    "no code at all"
    ^ self
!

codeOn:aStream inBlock:codeBlock for:aCompiler
    ^ self subclassResponsibility
!

codeStoreOn:aStream inBlock:codeBlock valueNeeded:valueNeeded for:aCompiler
    ^ self subclassResponsibility
! !

!PrimaryNode methodsFor:'evaluating'!

evaluate
    ^ self subclassResponsibility
!

store:aValue
    ^ self subclassResponsibility
! !

!PrimaryNode methodsFor:'printing'!

displayString
    ^ self subclassResponsibility
!

printOn:aStream indent:i
    ^ self subclassResponsibility
! !

!PrimaryNode methodsFor:'queries'!

isPrimary
    "return true, if this is a node for a primary (i.e. non-send)"

    ^ true
! !

!PrimaryNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libcomp/Attic/PrimaryNd.st,v 1.14 1995-12-03 12:15:02 cg Exp $'
! !
